unit MainFPWM;

{$mode objfpc}{$H+}

interface

uses
  LResources, fpHTTP, fpWeb, HTTPDefs, Classes, SysUtils;

type

  { TMainFPWebModule }

  TMainFPWebModule = class(TFPWebModule)
    procedure TFPWebActions0Request(Sender: TObject; ARequest: TRequest;
      AResponse: TResponse; var Handled: Boolean);
  public
    function CustomTemplate(const ATitle, ABody: string): string;
  end;

resourcestring
  {$I template.inc}

var
  STemplate: string = STemplate_rst;

implementation

{$R *.lfm}

uses
  LSUtils;

{ TMainFPWebModule }

procedure TMainFPWebModule.TFPWebActions0Request(Sender: TObject;
  ARequest: TRequest; AResponse: TResponse; var Handled: Boolean);
var
  VLazarusResourceStream: TLazarusResourceStream;
begin
  VLazarusResourceStream := TLazarusResourceStream.Create('Image', 'PNG');
  try
    AResponse.Content := CustomTemplate(
      'LSCaptcha', '<img src="data:image/png;base64,' +
      LSStreamToBase64Str(TStream(VLazarusResourceStream)) + '">');
  finally
    VLazarusResourceStream.Free;
  end;
end;

function TMainFPWebModule.CustomTemplate(const ATitle, ABody: string): string;
begin
  Result := Format(STemplate, [ATitle, ABody]);
end;

initialization
  {$I Image.lrs}
  RegisterHTTPModule('TMainFPWebModule', TMainFPWebModule);

end.

